from univention.lib.i18n import Translation

_ = Translation('univention-management-console-module-twofactor-selfservice').translate


class TwofactorException(Exception):
    message = _("Something went wrong")


class DisableTokenException(TwofactorException):
    message = _("Could not disable Token")


class DeleteTokenException(TwofactorException):
    message = _("Could not delete Token")


class UserNotFoundException(TwofactorException):
    message = _("User not found.")


class UnspecifiedErrorException(TwofactorException):

    def __init__(self, message=_("No message specified")):
        self.message = message


class TokenNotFoundException(TwofactorException):
    message = _("Token not found.")


class TwoTokensWithSameSerialException(TwofactorException):
    message = _("Illegal State, two Tokens with the same Serial")


class TokenAlreadyAssignedToOtherUserException(TwofactorException):
    message = _("Token is already assigned to another user. Please return it before assigning it again.")


class TokenAlreadyAssignedToUserException(TwofactorException):
    message = _("This User is already assigned to this Token.")


class InvalidOtpException(TwofactorException):
    message = _("OTP Value invalid")


class CouldNotEnableTokenException(TwofactorException):
    message = _("Error enabling Token")


class CouldNotDisableTokenException(TwofactorException):
    message = _("Error disabling Token")


class TokenCouldNotBeAssignedException(TwofactorException):
    mesage = _("Token could not be assigned.")


class QrTokenImpossibleSinceUserHasActiveHardwareTokenException(TwofactorException):
    message = _("Can't create QR Token since the User has an active Hardware Token.")


class QrTokenGenerationFailedException(TwofactorException):
    message = _("Error generating QR Code Token")


class TokenCouldNotBeUnassignedException(TwofactorException):
    message = _("Error unassigning Token from User")


class UserHasNoActiveTokensException(TwofactorException):
    message = _("There are no Tokens assigned to the User.")


class UnAuthorizedException(TwofactorException):
    message = _("You are not authorized for this action.")


class NoSchoolSelectedException(TwofactorException):
    message = _("Please select a School")


class NoSchoolAvailableException(TwofactorException):
    message = _("There is no school available for you to administrate. You need to be a member of the admins-yourschoolnamehere group.")


class PrivacyIdeaNotReachableException(TwofactorException):
    message = _("The Connection to the Token Service (PrivacyIDEA) failed.")


class ConfiguratonException(TwofactorException):
    message = _("Config Error, please contact the Administration.")


class ModuleTimeoutException(TwofactorException):
    # yes, there is no i18n here, this is to handle a timeout on the client side
    message = _("The module has timed out. Please reload the Page.")
