# Univention Twofactor Admin Module

This module incorporates the Administration (not Login or Auth) of the third party
solution "privacyIDEA" by netknights.

## Setup
Put User and Password for privacyIDEA in /etc/twofactor-selfservice.secret

```[privacyIDEA]
user=admin
pass=admin
```
The URL for the privacyIDEA installation is read from the privacyIDEA A record.

## Permissions
To allow 2FA administration, the user has to be added to the group `mfa-admins-<OU>` AND should
be authorized to view/edit the user objects (e.g. being a school administrator).

This package includes a listener module, to automatically add new users to the according `mfa-admins-<OU>` group.
Location: `/usr/lib/univention/directory-listener/system/dataport-schuposh-twofactor-admin-module.py`

## Token administration permissions
* TVM and Domain Admins (FVM, IQSH): UCS administration and Token management of all Domain Users
* School admins: Token Management of all users within their OU, including School admins

Matrix: https://filestore.knut.univention.de/owncloud/f/2790858

This group has the following policy attached to allow the usage of the admin-module:
`cn=2fa-admin-umc,cn=UMC,cn=policies,$ldap_base`

## UCR-Variables
* `privacyidea/saml/realm` - defines the realm which is querie dby this module. Should be set by `dataport-schuposh-towfactor-privacyidea-config`
* optional: `twofactor-admin/autosearch` - (de-) activates autosearch if false|true


## Process

* In the file `/etc/dataport-schuposh-mfa-admin-enabled-schools` the schools/OUs enabled for MFA are listed which are newline separated.
* The file is maintained via the `update-mfa-admin-group` command.
* By using the parameters `enable $OU` and `disable $OU` schools/OUs can be added/removed from the list.
* If the `update` parameter is passed to the script, the script reads the group members of the `admins-$OU` groups of all activated schools and writes them collectively to the central `mfa-admins` group.
* The parameters `enable` and `disable` also implicitly call an `update` internally, so that the group is immediately up-to-date.
* To keep the group `mfa-admins` up to date, there is a listener module which reacts to changes in the `admins-$OU` groups. When a change is made, the `update-mfa-admin-group update` script is called in `postrun()` method.
* The portal entry `2fa-administration` is enabled for the group `mfa-admins`, so that school admins of a school get access automatically after enabling the school.
* The associated UMC module is enabled via the `2fa-admin-umc` UMC policy. The UMC policy is attached to the `mfa-admins` group.
* If the group `mfa-admins` is missing in LDAP, the script automatically creates the group and attaches the UMC policy `2fa-admin-umc`.

![Chart](README-Chart.png)
